<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503346-CmeGetsInInfiniteLoopOnGenerics -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 8, 2008 at 9:34:27 pm</time-stamp>


<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>private</category>

<body package="PV-CME-Core" selector="injectBufferedTuplesIntoComputationsUntilAllDone">injectBufferedTuplesIntoComputationsUntilAllDone

	| formulasInBuffer inputFormulaIds tupleToTsList |	
	
	tupleToTsList := OrderedCollection new: heartbeatBuffer size.
	[heartbeatBuffer isEmpty]
		whileFalse:
			["build up a list of all formulas in the buffer"
			formulasInBuffer := Set new: 200.
			heartbeatBuffer do: [:array | formulasInBuffer add: array last formula].

			"find the formulaIds that do not depend on any other formulas in the buffer"
			inputFormulaIds := Set new: 200.
			formulasInBuffer do: 
				[:each | 
				(formulasInBuffer noneSatisfy: [:each2 | each dependsOnFormula: each2])
					ifTrue: [inputFormulaIds add: each id]].
		
			"build up a list of all timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList fastEmpty.
			heartbeatBuffer keysAndValuesDo: 
				[:midRidArray :tupleToTsArray | 
				(inputFormulaIds includes: midRidArray first)
					ifTrue: [tupleToTsList add: tupleToTsArray]].
	
			"remove the timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				heartbeatBuffer 
					removeMid: tupleToTsArray second metricId 
					rid: tupleToTsArray second resourceId 
					ifAbsent: []].
	
			"do onAddTuple: for each timeseries where the formula does not depend on any other formulas in the buffer.
			For tupleWindow type formulas this can result in more things being added to heartbeatBuffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				tupleToTsArray last onAddTuple: tupleToTsArray first]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>api</category>

<body package="PV-CME-Core" selector="addHeartbeatBufferedTuple:for:">addHeartbeatBufferedTuple: aMetricRecord for: cmeTimeSeries

	heartbeatBuffer
		atMid: cmeTimeSeries metricId
		rid: cmeTimeSeries resourceId
		put: (Array with: aMetricRecord with: cmeTimeSeries).</body>
</methods>



</st-source>
